Distribution:	CCux
Packager:	Karsten Brockmann <arcam@ccux-linux.de>	

Name:		libvpx
#Epoch:		0
Version:	0.9.5
Release:	1
License:	BSD
URL:		http://www.webmproject.org/tools/vp8-sdk/
Group:		Multimedia/Video	
Summary:	VP8 video codec SDK library
BuildRoot:	%{_tmppath}/%{name}-buildroot
BuildArch:	i686

# Sources:
Source:		%{name}-v%{version}.tar.bz2
Source101:      libvpx.pc
# Thanks to debian.
Source102:      libvpx.ver

# Patches:
Patch0:         libvpx-0.9.0-no-explicit-dep-on-static-lib.patch
# Fix for CVE-2010-4203
Patch1:		libvpx-fix-memory-corruption.patch

# Requires:

# BuildRequires:

# needed for optimized builds
BuildRequires: yasm-devel
BuildRequires: which

BuildRequires: doxygen

#Automatically resolved build dependencies
BuildRequires: glibc-devel
BuildRequires: pkg-config

%description
libvpx - the WebM VP8 Codec SDK allows you to integrate your applications with the VP8 video codec, a high quality, royalty free, open source codec deployed on millions of computers and devices worldwide. 

%package	devel
Summary:	%{name} development headers.
Group:		Development/
Requires:	%{name} = %{version}-%{release}

%description	devel
Header and include files for developing applications with %{name}.

%pre

%preun

%post
if [ -f /sbin/ldconfig ]; then
    /sbin/ldconfig
fi

%postun
if [ -f /sbin/ldconfig ]; then
    /sbin/ldconfig
fi

%prep
%setup -q -n %{name}-v%{version}
%patch0 -p1 -b .no-static-lib
%patch1 -p1

%build
%ifarch %{ix86}
%global vpxtarget x86-linux-gcc
%else
%ifarch x86_64
%global vpxtarget x86_64-linux-gcc
%else
%global vpxtarget generic-gnu
%endif
%endif

./configure --target=%{vpxtarget} --enable-pic --disable-install-srcs --enable-vp8 --enable-postproc --enable-runtime-cpu-detect

# Hack our optflags in.
sed -i "s|\"vpx_config.h\"|\"vpx_config.h\" %{optflags} -fPIC|g" libs-%{vpxtarget}.mk
sed -i "s|\"vpx_config.h\"|\"vpx_config.h\" %{optflags} -fPIC|g" examples-%{vpxtarget}.mk
sed -i "s|\"vpx_config.h\"|\"vpx_config.h\" %{optflags} -fPIC|g" docs-%{vpxtarget}.mk

make %{?_smp_mflags} verbose=true target=libs

# Really? You couldn't make this a shared library? Ugh.
# Oh well, I'll do it for you.
mkdir tmp
cd tmp
ar x ../libvpx_g.a
cd ..
gcc -fPIC -shared -pthread -lm -Wl,--no-undefined -Wl,-soname,libvpx.so.0 -Wl,--version-script,%{SOURCE102} -Wl,-z,noexecstack -o libvpx.so.0.0.0 tmp/*.o
rm -rf tmp

# Temporarily dance the static libs out of the way
mv libvpx.a libNOTvpx.a
mv libvpx_g.a libNOTvpx_g.a

# We need to do this so the examples can link against it.
ln -sf libvpx.so.0.0.0 libvpx.so

make %{?_smp_mflags} verbose=true target=examples
make %{?_smp_mflags} verbose=true target=docs

# Put them back so the install doesn't fail
mv libNOTvpx.a libvpx.a
mv libNOTvpx_g.a libvpx_g.a



%install
rm -Rf $RPM_BUILD_ROOT

make DIST_DIR=%{buildroot}%{_prefix} install

# Install the pkg-config file
mkdir -p %{buildroot}%{_libdir}/pkgconfig/
install -m0644 %{SOURCE101} %{buildroot}%{_libdir}/pkgconfig/
# Fill in the variables
sed -i "s|@PREFIX@|%{_prefix}|g" %{buildroot}%{_libdir}/pkgconfig/libvpx.pc
sed -i "s|@LIBDIR@|%{_libdir}|g" %{buildroot}%{_libdir}/pkgconfig/libvpx.pc
sed -i "s|@INCLUDEDIR@|%{_includedir}|g" %{buildroot}%{_libdir}/pkgconfig/libvpx.pc

mkdir -p %{buildroot}%{_includedir}/vpx/
install -p libvpx.so.0.0.0 %{buildroot}%{_libdir}
pushd %{buildroot}%{_libdir}
ln -sf libvpx.so.0.0.0 libvpx.so
ln -sf libvpx.so.0.0.0 libvpx.so.0
ln -sf libvpx.so.0.0.0 libvpx.so.0.0
popd
pushd %{buildroot}
# Stuff we don't need.
rm -rf usr/build/ usr/md5sums.txt usr/lib*/*.a usr/CHANGELOG usr/README
# Fix the binary permissions
chmod 755 usr/bin/*
popd

# strip debug symbols from binaries
find $RPM_BUILD_ROOT -type f -exec /usr/bin/strip --strip-debug '{}' ';'

%files
%defattr(-,root,root)
%{_bindir}/vpxdec
%{_bindir}/vpxenc
%{_libdir}/libvpx.so.*

%files devel
%defattr(-,root,root)
%{_includedir}/vpx
%{_pkgconfig}/libvpx.pc
%{_libdir}/libvpx.so


%clean
rm -Rf $RPM_BUILD_ROOT && rm -Rf $RPM_BUILD_DIR/%{name}-*

%changelog
* Sun Dec 19 2010 Karsten Brockmann <arcam@ccux-linux.de> 0.9.5-1
- Version update
* Thu Jul 22 2010 Karsten Brockmann <arcam@ccux-linux.de> 0.9.1-1
- Version update
* Thu May 20 2010 Karsten Brockmann <arcam@ccux-linux.de> 0.9.0-1
- initial CCux package release
